package loggerconfig_test

import (
	"testing"

	"git.frostfs.info/TrueCloudLab/frostfs-node/cmd/frostfs-node/config"
	loggerconfig "git.frostfs.info/TrueCloudLab/frostfs-node/cmd/frostfs-node/config/logger"
	configtest "git.frostfs.info/TrueCloudLab/frostfs-node/cmd/frostfs-node/config/test"
	"github.com/stretchr/testify/require"
)

func TestLoggerSection_Level(t *testing.T) {
	t.Run("defaults", func(t *testing.T) {
		v := loggerconfig.Level(configtest.EmptyConfig())
		require.Equal(t, loggerconfig.LevelDefault, v)
	})

	const path = "../../../../config/example/node"

	fileConfigTest := func(c *config.Config) {
		v := loggerconfig.Level(c)
		require.Equal(t, "debug", v)
	}

	configtest.ForEachFileType(path, fileConfigTest)

	t.Run("ENV", func(t *testing.T) {
		configtest.ForEnvFileType(t, path, fileConfigTest)
	})
}
