// Package config provides the common configuration options for write cache implementations.
package config

import (
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/writecache/writecachebadger"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/writecache/writecachebbolt"
)

// Type is the write cache implementation type.
type Type int

const (
	TypeBBolt Type = iota
	TypeBadger
)

// Options are the configuration options for the write cache.
type Options struct {
	Type          Type
	BBoltOptions  []writecachebbolt.Option
	BadgerOptions []writecachebadger.Option
}
